/*!
 * @file blink.h
 */

#ifndef _BLINK_H
#define _BLINK_H

#include "world_entity.h"
#include "effects/billboard.h"

class Material;
class TiXmlElement;
//class Billboard;

class Blink : public WorldEntity
{
  ObjectListDeclaration(Blink);
  public:
    Blink(const TiXmlElement* root = NULL);
    virtual ~Blink();

    void init();
    void loadParams(const TiXmlElement* root);

    void setPosition(float x, float y, float z) { this->position = Vector(x, y, z); }
    void setSize(float s) { this->size = s; this->bBoard->setSize(this->size, this->size); }
    void setOmega(float w) { this->omega = w; }
    void setColor(float r, float g, float b) { this->color = Vector(r, g, b); }
    //void setTexture(const std::string& textureFile);

    virtual void tick(float dt);
    virtual void draw() const;

  private:
    Material*         material;
    Billboard*        bBoard;
    Vector            position;
    Vector            color;
    float             angle;
    float             omega;
    float             blinkStr;
    float             size;             //! only one float caus' its quadratical
};

#endif /* _BLINK_H */
